
package de.ivu.elect.business.person.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.person.entity.Tag;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractTagEdit {

  @Inject
  protected TagDAO dao;

  @Inject
  protected TagExtendedDAO extendedDao;

  public void delete(Tag entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(Tag entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(Tag entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected Tag getAttachedEntity(Tag entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected Tag getAttachedAndRefreshedEntity(Tag entity) {
    return dao.refresh(entity);
  }
}
